/* <nage02.h>
 *
 * Copyright 1996 Numerical Algorithms Group
 *
 * Include file for NAG C Library e02 Chapter
 *
 * Mark 4, revised, 1996.
 * Mark 5 revised. IER-2147 (Feb 1998).
 * Mark 6 revised. IER-3029 (July 2000).
 */
#ifndef NAGE02
#define NAGE02
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* begin proto */
  extern NAG_DLL_EXPIMP void NAG_CALL e02adc(Integer m,Integer kplus1,
                                             Integer nrows,double x[],double y[],
                                             double w[],double a[],double s[],NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02aec(Integer nplus1,double a[],double xcap,double *p,NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02afc(Integer nplus1,double f[],
                                             double a[],NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL e02agc(Nag_OrderType order, Integer m, Integer k, double xmin, double xmax, const double x[], const double y[], const double w[], Integer mf, const double xf[], const double yf[], const Integer p[], double a[], double s[], Integer *n, double resid[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02ahc(Integer n, double xmin, double xmax, const double a[], Integer ia1, double *patm1, double adif[], Integer iadif1, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02ajc(Integer n, double xmin, double xmax, const double a[], Integer ia1, double qatm1, double aint[], Integer iaint1, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02akc(Integer n, double xmin, double xmax, const double a[], Integer ia1, double x, double *result, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02bac(Integer m, double x[], double y[],
                                             double weights[], double *ss, Nag_Spline *spline,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02bbc(double x, double *s, Nag_Spline *spline, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02bcc(Nag_DerivType derivs, double x, double s[4], 
                                             Nag_Spline *spline, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02bdc(Nag_Spline *spline, double *integral, 
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02bec(Nag_Start start, Integer m, double x[], double y[],
                                             double weights[], double s, Integer nest,
                                             double *fp, Nag_Comm *warmstartinf,
                                             Nag_Spline *spline, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02cac(const Integer m[], Integer n, Integer k, Integer l, const double x[], const double y[], const double f[], const double w[], double a[], const double xmin[], const double xmax[], const double nux[], Integer inuxp1, const double nuy[], Integer inuyp1, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02cbc(Integer mfirst, Integer mlast, Integer k, Integer l, const double x[], double xmin, double xmax, double y, double ymin, double ymax, double ff[], const double a[], NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02dac(Integer m, const double x[], const double y[], const double f[], const double w[], const Integer Point[], double dl[], double eps, double *sigma, Integer *rank, Nag_2dSpline *spline, NagError *fail);


  extern NAG_DLL_EXPIMP void NAG_CALL e02dcc(Nag_Start start, Integer mx, double x[], Integer my,
                                             double y[], double f[], double s, Integer nxest,
                                             Integer nyest, double *fp, Nag_Comm *warmstartinf,
                                             Nag_2dSpline *spline, NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02ddc(Nag_Start start, Integer m, double x[], double y[],
                                             double f[], double weights[], double s, 
                                             Integer nxest, Integer nyest, double *fp,
                                             Integer *rank, double *warmstartinf,
                                             Nag_2dSpline *spline,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02dec(Integer m, double x[], double y[],
                                             double ff[], Nag_2dSpline *spline,
                                             NagError *fail);

  extern NAG_DLL_EXPIMP void NAG_CALL e02dfc(Integer mx, Integer my, double x[], double y[], 
                                             double ff[], Nag_2dSpline *spline, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02gac(Nag_OrderType order, Integer m, double a[], double b[], Integer nplus2, double toler, double x[], double *resid, Integer *rank, Integer *iter, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02gcc(Nag_OrderType order, Integer m, Integer n, double a[], double b[], double tol, double *relerr, double x[], double *resmax, Integer *rank, Integer *iter, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02rac(Integer ia, Integer ib, const double c[], double a[], double b[], NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02rbc(const double a[], Integer ia, const double b[], Integer ib, double x, double *ans, NagError *fail);
 

  extern NAG_DLL_EXPIMP void NAG_CALL e02zac(Integer px, Integer py, const double lamda[], const double mu[], Integer m, const double x[], const double y[], Integer Point[], NagError *fail);




#ifdef NAGLIBANDSTINCLUDE
#include <nage02aux.h>
 #endif
 
  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGE02 */
