/* <nage05.h>
 *
 * Copyright 2006 Numerical Algorithms Group
 *
 * Include file for NAG C Library e05 Chapter
 *
 * Mark 9, 2006.
 *
 */
#ifndef NAGE05
#define NAGE05
/// TD ML 06-10-2011 ORG-2987 NAG_HEADERS_OC_COMPILE
#ifndef _MSC_VER
	#pragma dll(ONAG8)
#endif // !_MSC_VER
/// end NAG_HEADERS_OC_COMPILE
#ifdef __cplusplus
extern "C"
{
#endif
  /* This header file uses the type FILE,  hence stdio.h has to be 
   * included.
   */
#include <stdio.h>
  /* begin proto */

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jac(Integer n, Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jbc(Integer n, NAG_E05JBC_FUN objfun,
                       Nag_BoundType bound, Nag_MCSInitMethod initmethod,
                       double bl[], double bu[], Integer ninit, double inlist[],
                       Integer numpts[], Integer initpt[], NAG_E05JBC_MON monit, 
                       double x[], double *obj, Nag_E05State *state, Nag_Comm *comm,
                       NagError *fail); 
  
  /* Cheat, same prototype as monit in e05jbct.c */
  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jbk (Integer n, Integer ncall, const double xbest[], const Integer icount[], Integer ninit, const double inlist[], const Integer numpts[], const Integer initpt[], Integer nbaskt, const double xbaskt[], const double boxl[], const double boxu[], Integer nstate, Nag_Comm *comm, Integer *inform);
    
  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jcc(Nag_FileID fileid, Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jdc(const char * optstr, Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jec(const char * optstr, const char * cvalue,
                       Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jfc(const char * optstr, Integer ivalue,
                       Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jgc(const char * optstr, double rvalue,
                       Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  Integer NAG_CALL e05jhc(const char * optstr,
                          Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jkc(const char * optstr, Integer *ivalue,
                       Nag_E05State *state, NagError *fail); 

  extern NAG_DLL_EXPIMP
  void NAG_CALL e05jlc(const char * optstr, double *rvalue,
                       Nag_E05State *state, NagError *fail); 

#ifdef NAGLIBANDSTINCLUDE
#include <nage05aux.h>
#endif

  /* end proto */
#ifdef __cplusplus
}
#endif
#endif /* not NAGE05 */
